
%define fontconfig_version    2.12.6-2
%define freetype2_version     2.9.1-2
%define libimagequant_version 2.12.3-1
%define libjpeg_version       9c-1
%define libpng_version        1.6.37-1
%define libtiff_version       4.0.10-1
%define libwebp_version       1.0.2-1
%define libXpm_version        3.5.12-1
%define pkgconfig_version     0.28-1
%define zlib_version          1.2.3-7

%define _libdir64 %{_prefix}/lib64

Summary:       A graphics library for quick creation of PNG or JPEG images
Name:          gd
Version:       2.2.5
Release:       1
Group:         System Environment/Libraries
License:       MIT
URL:           http://libgd.github.io/
Source0:       https://github.com/libgd/libgd/releases/download/%{name}-%{version}/libgd-%{version}.tar.gz

Patch0:        %{name}-%{version}-aix.patch
# CVE-2018-5711 - https://github.com/libgd/libgd/commit/a11f47475e6443b7f32d21f2271f28f417e2ac04
Patch2:        gd-2.2.5-upstream.patch
# CVE-2018-1000222 - https://github.com/libgd/libgd/commit/ac16bdf2d41724b5a65255d4c28fb0ec46bc42f5
Patch3:        gd-2.2.5-gdImageBmpPtr-double-free.patch

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: fontconfig-devel >= %{fontconfig_version}
BuildRequires: freetype2-devel >= %{freetype2_version}
BuildRequires: libimagequant-devel >= %{libimagequant_version}
BuildRequires: libjpeg-devel >= %{libjpeg_version}
BuildRequires: libpng-devel >= %{libpng_version}
BuildRequires: libtiff-devel >= %{libtiff_version}
BuildRequires: libwebp-devel >= %{libwebp_version}
BuildRequires: zlib-devel >= %{zlib_version}
BuildRequires: pkg-config >= %{pkgconfig_version}
BuildRequires: libXpm-devel >= %{libXpm_version}

Requires: fontconfig >= %{fontconfig_version}
Requires: freetype2 >= %{freetype2_version}
Requires: libimagequant >= %{libimagequant_version}
Requires: libjpeg >= %{libjpeg_version}
Requires: libpng >= %{libpng_version}
Requires: libtiff >= %{libtiff_version}
Requires: libwebp >= %{libwebp_version}
Requires: zlib >= %{zlib_version}
Requires: libXpm >= %{libXpm_version}

%description
The gd graphics library allows your code to quickly draw images
complete with lines, arcs, text, multiple colors, cut and paste from
other images, and flood fills, and to write out the result as a PNG or
JPEG file. This is particularly useful in Web applications, where PNG
and JPEG are two of the formats accepted for inline images by most
browsers. Note that gd is not a paint program.

The library is available as 32-bit and 64-bit.


%package progs
Summary:  Utility programs that use libgd
Group:    Applications/Multimedia
Requires: %{name} = %{version}-%{release}
Requires: fontconfig >= %{fontconfig_version}
Requires: freetype2 >= %{freetype2_version}
Requires: libimagequant >= %{libimagequant_version}
Requires: libjpeg >= %{libjpeg_version}
Requires: libpng >= %{libpng_version}
Requires: libtiff >= %{libtiff_version}
Requires: libwebp >= %{libwebp_version}
Requires: zlib >= %{zlib_version}
Requires: libXpm >= %{libXpm_version}

%description progs
The gd-progs package includes utility programs supplied with gd, a
graphics library for creating PNG and JPEG images. If you install
these, you must also install gd.


%package devel
Summary:  The development libraries and header files for gd
Group:    Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The gd-devel package contains the development libraries and header
files for gd, a graphics library for creating PNG and JPEG graphics.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc_r -q64" or "gcc -maix64".


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q -n libgd-%{version}
%patch0
%patch2 -p1 -b .upstream
%patch3 -p1 -b .gdImageBmpPtr-free
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="xlc_r"
cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --enable-static --enable-shared
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --enable-shared --enable-static
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/COPYING
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files progs
%defattr(-,root,system,-)
%{_bindir}/annotate*
%{_bindir}/bdftogd*
%{_bindir}/gd2copypal*
%{_bindir}/gd2togif*
%{_bindir}/gd2topng*
%{_bindir}/gdcmpgif*
%{_bindir}/gdparttopng*
%{_bindir}/gdtopng*
%{_bindir}/giftogd2*
%{_bindir}/pngtogd*
%{_bindir}/webpng*
/usr/bin/annotate*
/usr/bin/bdftogd*
/usr/bin/gd2copypal*
/usr/bin/gd2togif*
/usr/bin/gd2topng*
/usr/bin/gdcmpgif*
/usr/bin/gdparttopng*
/usr/bin/gdtopng*
/usr/bin/giftogd2*
/usr/bin/pngtogd*
/usr/bin/webpng*


%files devel
%defattr(-,root,system,-)
%{_bindir}/gdlib-config*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
/usr/bin/gdlib-config
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Wed May 29 2019 Michael Perzl <michael@perzl.org> - 2.2.5-1
- updated to version 2.2.5

* Wed May 29 2019 Michael Perzl <michael@perzl.org> - 2.0.35-6
- added all latest available security patches

* Tue Apr 27 2010 Michael Perzl <michael@perzl.org> - 2.0.35-5
- recompiled thread-safe with cc_r

* Wed Apr 23 2008 Michael Perzl <michael@perzl.org> - 2.0.35-4
- some minor spec file fixes

* Sat Mar 29 2008 Michael Perzl <michael@perzl.org> - 2.0.35-3
- changed to FreeType version 2

* Thu Jan 03 2008 Michael Perzl <michael@perzl.org> - 2.0.35-2
- included both 32-bit and 64-bit shared objects

* Fri Sep 28 2007 Michael Perzl <michael@perzl.org> - 2.0.35-1
- first version for AIX V5.1 and higher
